"""
This type stub file was generated by pyright.
"""

from typing import Literal, Optional, Tuple, Union
from drawlib.v0_1.private.core.model import ShapeStyle, ShapeTextStyle
from drawlib.v0_1.private.core_canvas.base import CanvasBase
from drawlib.v0_1.private.util import error_handler

"""Canvas's original arrow feature implementation module."""
class CanvasOriginalArrowFeature(CanvasBase):
    """Canvas's original arrow feature implementation module.

    This class provides methods to draw single-headed and double-headed arrows
    on a canvas. The arrows can be customized with various styles for the tail,
    head, and optional text annotations.
    """
    def __init__(self) -> None:
        """Initialize CanvasOriginalArrowFeature.

        This initializes the CanvasOriginalArrowFeature class, inheriting from
        CanvasBase. It sets up the basic canvas features required for drawing
        original arrow shapes.
        """
        ...
    
    @error_handler
    def arrow(self, xy1: Tuple[float, float], xy2: Tuple[float, float], tail_width: float, head_width: float, head_length: float, head: Literal["->", "<-", "<->",] = ..., style: Union[ShapeStyle, str, None] = ..., text: str = ..., textsize: Optional[float] = ..., textstyle: Union[ShapeTextStyle, str, None] = ...) -> None:
        """Draw single and double-headed arrow.

        Args:
            xy1: Tuple[float, float]: Arrow start point.
            xy2: Tuple[float, float]: Arrow end point.
            tail_width: float: Width of the arrow tail.
            head_width: float: Width of the arrow head.
            head_length: float: Length of the arrow head.
            head: Literal["->", "<-", "<->"]: Arrow head style ("->", "<-", "<->").
            style: Union[ShapeStyle, str, None]: Optional style of the arrow.
            text: str: Optional text to display at the center of the arrow.
            textsize: Optional[float]: Optional size of the text.
            textstyle: Union[ShapeTextStyle, str, None]: Optional style of the text.

        Returns:
            None
        """
        ...
    


