"""
This type stub file was generated by pyright.
"""

"""Download assets implementations."""
def download_if_not_exist(file_path: str, download_url: str, md5_hash: str) -> None:
    """Download asset if it doesn't exist locally or corrupted.

    Download an asset file from the specified URL if it does not already exist locally,
    or if its MD5 checksum does not match the provided hash.

    Args:
        file_path (str):
            Local file path where the downloaded file will be saved or already exists.
        download_url (str):
            URL from which the file should be downloaded if it doesn't exist locally.
        md5_hash (str):
            Expected MD5 checksum of the file. If the file already exists locally,
            its checksum is compared against this value to determine if a re-download is necessary.

    Raises:
        RuntimeError: If any of the following conditions occur:
            - File download encounters an error.
            - Downloaded file is not saved properly.
            - Downloaded file's checksum does not match the expected MD5 hash.

    Returns:
        None

    Notes:
        - Creates the parent directory of file_path if it does not exist.
        - Uses MD5 checksum to verify the integrity of the downloaded file.
        - Utilizes urllib.request.urlopen for downloading the file.
        - Logs download progress and errors using the 'logger' instance from drawlib.v0_1.private.logging.

    """
    ...

