"""
This type stub file was generated by pyright.
"""

from typing import Literal, Optional, Tuple, Union
from drawlib.v0_1.private.core.model import ShapeStyle, ShapeTextStyle
from drawlib.v0_1.private.util import error_handler

"""bubblespeech() implementation module."""
@error_handler
def bubblespeech(xy: Tuple[float, float], width: float, height: float, tail_edge: Literal["left", "top", "right", "bottom"], tail_from_ratio: float, tail_vertex_xy: Tuple[float, float], tail_to_ratio: float, style: Union[ShapeStyle, str, None] = ..., text: str = ..., textsize: Optional[float] = ..., textstyle: Union[ShapeTextStyle, str, None] = ...) -> None:
    """Draw a bubble speech on the canvas.

    Args:
        xy (Tuple[float, float]): The (x, y) coordinates of the bottom-left corner of the bubble.
        width (float): The width of the bubble.
        height (float): The height of the bubble.
        tail_edge (Literal["left", "top", "right", "bottom"]): The edge on which the tail will be positioned.
        tail_from_ratio (float): The ratio along the edge where the tail starts.
        tail_vertex_xy (Tuple[float, float]): The (x, y) coordinates of the tail's vertex.
        tail_to_ratio (float): The ratio along the edge where the tail ends.
        style (Union[ShapeStyle, str, None], optional): The style of the bubble. Defaults to None.
        text (str, optional): The text to display inside the bubble. Defaults to an empty string.
        textsize (Optional[float], optional): The size of the text. Defaults to None.
        textstyle (Union[ShapeTextStyle, str, None], optional): The style of the text. Defaults to None.

    Returns:
        None

    """
    ...

