"""
This type stub file was generated by pyright.
"""

from typing import Tuple, Union

"""Validate color data."""
def validate_alpha(name: str, value: float) -> None:
    """Validate alpha transparency value.

    Args:
        name (str): Name of the argument or attribute being validated.
        value (float): Alpha value to validate.

    Raises:
        ValueError: If value is not a float or integer, or if it is not within the range [0.0, 1.0].
    """
    ...

def validate_color(name: str, value: Union[Tuple[int, int, int], Tuple[int, int, int, float]]) -> None:
    """Validate RGB or RGBA color tuple.

    Args:
        name (str): Name of the argument or attribute being validated.
        value (Union[Tuple[int, int, int], Tuple[int, int, int, float]]): Color tuple to validate.

    Raises:
        ValueError: If value is not a tuple, if its length is not 3 or 4,
                    if RGB values are not integers within [0, 255],
                    or if alpha value (if present) is not a float within [0.0, 1.0].
    """
    ...

