"""
This type stub file was generated by pyright.
"""

from typing import Union

"""Validate line data."""
def validate_style(name: str, value: str) -> None:
    """Validate line style.

    Args:
        name (str): Name of the argument or attribute being validated.
        value (str): Line style to validate.

    Raises:
        ValueError: If value is not one of ["solid", "dashed", "dotted", "dashdot"].
    """
    ...

def validate_arrowhead(name: str, value: str) -> None:
    """Validate arrowhead style.

    Args:
        name (str): Name of the argument or attribute being validated.
        value (str): Arrowhead style to validate.

    Raises:
        ValueError: If value is not one of ["", "->", "<-", "<->"].
    """
    ...

def validate_bend(arg_name: str, value: Union[int, float]) -> None:
    """Validate bend value for a line.

    Args:
        arg_name (str): Name of the argument or attribute being validated.
        value (Union[int, float]): Bend value to validate.

    Raises:
        ValueError: If value is not an int or float within the range (-2.0, 2.0).
    """
    ...

